% Ps = vvPlotFreqPowerSpectrum( x, t , plt)
% Calculate the power spectrum using the 
%
% x : vector containing the signal in time
% t : sampling period (1/sampling rate)
%plt: plt=1-will plot, plt=0-will not plot. Default plt=1
%
function Ps = vvPlotFreqPowerSpectrum( x, t , plt, max1)

if ~exist('plt','var')
	plt = 1;
end

if ~exist('max1','var')
	max1 = false;
end


%% Calculate the Frequency Power Spectrum
Ps = zeros(size(x,1),1);
for kk=1:size(x,2)
	Fx = fft(x(:,kk));
	Ps = Ps +  Fx.*conj(Fx);
end
Ps = Ps ./ size(x,2);
%% Check for plotting request 
if plt==1
	%% Calculate the Frequency Variable and its Delta
	n = size(x,1);
	if ~exist('t','var')
		df = 2/n;
	else
		df = 1/(t*n);
	end
	f = 0:df:(n-1)*df;

	%% Do the Plot
	n2 = floor(n/2);
	Psplt = Ps(1:n2);
	if max1
		Psplt = Psplt./max(Psplt);
	end
	semilogy(f(1:n2),Psplt(1:n2),'LineWidth',2);
	grid on;
	ylabel('| fft(x) |^2');
	if ~exist('t','var')
		xlabel('Digital Frequency x {\pi}');
	else
		xlabel('Frequency');
	end
end

end

